明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 2411|回复: 2

CAD——生成图片

[复制链接]
发表于 2009-11-25 10:26:00 | 显示全部楼层 |阅读模式

 在『Kean』的BlockView.NET中有生成图片的功能,拷贝一个View,然后调用RenderToImage()方法,可是为什么总是提示【对象的当前状态使该操作无效】,请大家帮帮忙?

  private void OutputImageMenuItem_Click(object sender, EventArgs e)
    {
      // pick the place where o output the image type
      Autodesk.AutoCAD.Windows.SaveFileDialog dialog = new Autodesk.AutoCAD.Windows.SaveFileDialog("RenderToImage", null, "jpg;png;tif;bmp", "BlockViewSnapshotBrowseDialog", Autodesk.AutoCAD.Windows.SaveFileDialog.SaveFileDialogFlags.AllowAnyExtension);
      // if all is ok?
      if (DialogResult.OK == dialog.ShowDialog())
      {
        // create an offscreen device
        using (Device device = new Device())
        {
          // get the size of the GS view
          Size size = mPreviewCtrl.ClientRectangle.Size;
          // resize the device to this
          device.OnSize(size);
          device.BackgroundColor = Color.Black;
          device.SetLogicalPalette(GSUtil.MyAcadColorMs);
          device.OnRealizeBackgroundPalette();
          device.OnRealizeForegroundPalette();
         
          // make a copy of the gs view
          using (Autodesk.AutoCAD.GraphicsSystem.View view = mPreviewCtrl.mpView.Clone(true, true))
          {
            try
            {
              // add it to the device
              device.Add(view);
              // now render the image to a bitmap
              using (System.Drawing.Bitmap bitmap = view.RenderToImage())
              {
                // now save it out!!
                bitmap.Save(dialog.Filename);
              }
            }
            finally
            {
              // do a clear up
              device.EraseAll();
            }
          }
        }
      }
    }

发表于 2009-11-25 15:07:00 | 显示全部楼层
        public Bitmap GetImage()
        {
            return m_Device.GetSnapshot(m_View.Viewport);
        }
 楼主| 发表于 2009-11-25 16:26:00 | 显示全部楼层

真的可以实现生成图片。

我在这里提供第二种方法:

  调用WINAPI中的BitBlt()截屏方法,也可以实现。实现的效果一样。不过还是弧哥的方法简单,明了。

您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 20:32 , Processed in 0.183132 second(s), 23 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表